import { get, isString, set } from 'lodash';
import React from 'react';
export class DConfigContextManager {
    get parent() {
        return this._parent;
    }
    get root() {
        let data = this;
        while (data.parent) {
            data = data.parent;
        }
        return data;
    }
    constructor(data) {
        Object.defineProperty(this, "namespace", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "componentConfigs", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "i18n", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "layout", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "globalScroll", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "_parent", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: null
        });
        this.namespace = data.namespace;
        this.componentConfigs = data.componentConfigs;
        this.i18n = data.i18n;
        this.layout = data.layout;
        this.globalScroll = data.globalScroll;
    }
    setParent(parent) {
        this._parent = parent;
    }
    mergeContext(context) {
        const newContext = {};
        const mergeContext = (path, defaultValue) => {
            var _a;
            set(newContext, path, (_a = get(context, path)) !== null && _a !== void 0 ? _a : defaultValue);
        };
        mergeContext(['namespace'], this.namespace);
        mergeContext(['componentConfigs'], this.componentConfigs);
        mergeContext(['i18n', 'lang'], this.i18n.lang);
        const mergeResources = (path, value) => {
            if (isString(value)) {
                mergeContext(path, value);
            }
            else {
                Object.entries(value).forEach(([k, v]) => {
                    mergeResources(path.concat(k), v);
                });
            }
        };
        mergeResources(['i18n', 'resources'], this.i18n.resources);
        mergeContext(['layout', 'pageScrollEl'], this.layout.pageScrollEl);
        mergeContext(['layout', 'contentResizeEl'], this.layout.contentResizeEl);
        return newContext;
    }
}
export const DConfigContext = React.createContext(null);
