var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import { isFunction, isNumber, isUndefined } from 'lodash';
import React, { useRef, useState } from 'react';
import { useForkRef, useIsomorphicLayoutEffect } from '@react-devui/hooks';
import { getClassName } from '@react-devui/utils';
import { useGeneralContext, useDValue } from '../../hooks';
import { registerComponentMate } from '../../utils';
import { DBaseDesign } from '../_base-design';
import { DBaseInput } from '../_base-input';
import { useFormControl } from '../form';
import { useComponentConfig, usePrefixConfig } from '../root';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DTextarea' });
function Textarea(props, ref) {
    const _a = useComponentConfig(COMPONENT_NAME, props), { dFormControl, dModel, dRows, dResizable = true, dShowCount = false, onModelChange } = _a, restProps = __rest(_a, ["dFormControl", "dModel", "dRows", "dResizable", "dShowCount", "onModelChange"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    const { gSize } = useGeneralContext();
    //#endregion
    //#region Ref
    const textareaRef = useRef(null);
    const combineTextareaRef = useForkRef(textareaRef, ref);
    //#endregion
    const lineHeight = gSize === 'larger' ? 28 : gSize === 'smaller' ? 20 : 24;
    const formControlInject = useFormControl(dFormControl);
    const [value, changeValue] = useDValue('', dModel, onModelChange, undefined, formControlInject);
    const disabled = restProps.disabled || (dFormControl === null || dFormControl === void 0 ? void 0 : dFormControl.control.disabled);
    const resizable = dResizable && isUndefined(dRows);
    const getRowNum = () => {
        if (textareaRef.current) {
            const cssText = textareaRef.current.style.cssText;
            textareaRef.current.style.cssText += 'overflow:hidden;height:32px;min-height:unset;';
            setRowNum(Math.round((textareaRef.current.scrollHeight - 6) / lineHeight));
            textareaRef.current.style.cssText = cssText;
        }
    };
    const [rowNum, setRowNum] = useState(1);
    useIsomorphicLayoutEffect(() => {
        getRowNum();
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    const heightStyle = (() => {
        let overflow;
        let height;
        let minHeight = lineHeight + 8;
        let maxHeight;
        if (!isUndefined(dRows)) {
            overflow = 'hidden';
            height = rowNum * lineHeight + 8;
            if (dRows !== 'auto') {
                if (isNumber(dRows.minRows)) {
                    minHeight = dRows.minRows * lineHeight + 8;
                }
                if (isNumber(dRows.maxRows)) {
                    maxHeight = dRows.maxRows * lineHeight + 8;
                    if (maxHeight < height) {
                        overflow = undefined;
                    }
                }
            }
        }
        return { overflow, height, minHeight, maxHeight };
    })();
    return (_jsxs(_Fragment, { children: [_jsx(DBaseDesign, Object.assign({ dComposeDesign: false, dFormDesign: {
                    control: dFormControl,
                } }, { children: ({ render: renderBaseDesign }) => (_jsx(DBaseInput, Object.assign({ dFormControl: dFormControl, dLabelFor: true }, { children: ({ render: renderBaseInput }) => renderBaseDesign(renderBaseInput(_jsx("textarea", Object.assign({}, restProps, { ref: combineTextareaRef, className: getClassName(restProps.className, `${dPrefix}textarea`, {
                            [`${dPrefix}textarea--${gSize}`]: gSize,
                        }), style: Object.assign(Object.assign(Object.assign({}, restProps.style), heightStyle), { lineHeight: `${lineHeight}px`, resize: resizable ? undefined : 'none' }), value: value, disabled: disabled, onChange: (e) => {
                            var _a;
                            (_a = restProps.onChange) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                            changeValue(e.currentTarget.value);
                            getRowNum();
                        } })))) }))) })), dShowCount !== false && (_jsx("div", Object.assign({ className: `${dPrefix}textarea__count` }, { children: isFunction(dShowCount)
                    ? dShowCount(value.length)
                    : isUndefined(restProps.maxLength)
                        ? value.length
                        : `${value.length} / ${restProps.maxLength}` })))] }));
}
export const DTextarea = React.forwardRef(Textarea);
